##################################################################
################ B3D ANALYTICS FOR AIR QUALITY ###################
##################################################################



# KS-TEST & T-TEST -----


load("ozone.RData")
SRS_ozono <- na.omit(temp_ozono[temp_ozono$Temperatura>=30,]) #275
B3D_ozono <- na.omit(temp_ozono) #125949

load("nitrogendioxide.RData")

SRS_NO2 <- na.omit(temp_NO2[temp_NO2$Temperatura>=30,]) #267 
B3D_NO2 <- na.omit(temp_NO2) #126056

SRSsample <- SRS_NO2$NO2
B3Dsample <- B3D_NO2$NO2

ks.test(SRS_ozono$Ozono,B3D_ozono$Ozono)
ks.test(SRS_NO2$NO2,B3D_NO2$NO2)

t.test(SRS_ozono$Ozono,B3D_ozono$Ozono)
t.test(SRS_NO2$NO2,B3D_NO2$NO2)

# BOOTSTRAP ALGORITHM: O3 -----


load("ozone.RData")
SRS_ozono <- na.omit(temp_ozono[temp_ozono$Temperatura>=30,]) #275
B3D_ozono <- na.omit(temp_ozono) #125949
SRSsample <- SRS_ozono$Ozono
B3Dsample <- B3D_ozono$Ozono
n <- length(SRSsample)
N <- length(B3Dsample)


Xbar_O3 <- mean(SRSsample)
Ybar_O3 <- mean(B3Dsample)

h_pil <- density(SRSsample)$bw
b_pil <- density(B3Dsample)$bw


p <- 100000
obtida <-0.05
num_vent<-101
vent_ini<-obtida/10
vent_fin<-obtida*10000
rho<-(vent_fin/vent_ini)^(1/(num_vent-1))
ventanas<-vent_ini*rho^(0:(num_vent-1))
ventanab <- ventanas
ventanah <- ventanas
v <- length(ventanas)

part_2<- matrix(0, v, p)
part<- matrix(0, v, p)
dens_x<- matrix(0, v, p)
dens_y<- matrix(0, v, p)
inv_wbh <- matrix(0, v, p)
mu_est_wbh_O3_boots <- matrix(0, v, v)
ecmwbh_O3_boots<-matrix(0, v, v)


B <- 100
dif_O3_boots <- matrix(0, 10201, B)
set.seed(123456)
tiempo.ini<-proc.time()
for (j in 1:B){
  xboots <- sample(SRSsample, n, replace = TRUE) + h_pil*rnorm(n, 0, 1)
  yboots <- sample(B3Dsample, N, replace = TRUE) + b_pil*rnorm(N, 0, 1) 

  for (s in 1:v)
  {
    a <- min(xboots) - ventanah[s]*3
    c <- max(xboots) + ventanah[s]*3
  
  
    part_2<-density(xboots,ventanah[s],n=p,from=a,to=c)$x
    dens_x[s,]<-density(xboots,ventanah[s],n=p,from=a,to=c)$y
    dens_x_h <- approxfun(part_2,dens_x[s,],rule=2)
  
    for (i in 1:v)
    {
      a <- min(yboots)- ventanab[i]*3
      c <- max(yboots) + ventanab[i]*3
    
    
      part<-density(yboots,ventanab[i],n=p,from=a,to=c)$x
      dens_y[i,]<-density(yboots,ventanab[i],n=p,from=a,to=c)$y
      dens_y_b <- approxfun(part,dens_y[i,],rule=2)
    
      inv_weight_bh <-function(x)
      {
        result_4<-dens_x_h(x)/dens_y_b(x)
        return(result_4)
      }
    
      inv_w_y_bh<-inv_weight_bh(yboots)
      y_div_w_y_bh<-yboots*inv_w_y_bh
    
      mu_est_wbh_O3_boots[s,i]<-mean(y_div_w_y_bh)/mean(inv_w_y_bh)
      ecmwbh_O3_boots[s,i]<-ecmwbh_O3_boots[s,i]+(mu_est_wbh_O3_boots[s,i]-Xbar_O3)^2
      }
  }
  dif_O3_boots[,j] <- as.vector(t((mu_est_wbh_O3_boots-Xbar_O3)^2)) 
  #1:101 bwh1 101 bwb, 102:202 bwh2 101bwb...
}

tiempo.fin<-proc.time()
tiempo<-tiempo.fin-tiempo.ini;tiempo

ntrim <- 0.99*B
median_O3_boots <- apply(dif_O3_boots,1,median)
O3_boots_ord <- t(apply(dif_O3_boots,1,sort))
ecmwbh_trim_O3_boots <- apply(O3_boots_ord[,1:ntrim],1,mean)

ecmwbh_O3_boots<-ecmwbh_O3_boots/B;ecmwbh_O3_boots

min(ecmwbh_O3_boots);which.min(ecmwbh_O3_boots)
min(median_O3_boots);which.min(median_O3_boots)
min(ecmwbh_trim_O3_boots);which.min(ecmwbh_trim_O3_boots)

indb_O3_boots <- ceiling(which.min(ecmwbh_O3_boots)/101)
indh_O3_boots <- which.min(ecmwbh_O3_boots)-101*floor(which.min(ecmwbh_O3_boots)/101-0.01)

indh_O3_boots;indb_O3_boots



# BOOTSTRAP ALGORITHM: NO2 -----

load("nitrogendioxide.RData")

SRS_NO2 <- na.omit(temp_NO2[temp_NO2$Temperatura>=30,]) #267 
B3D_NO2 <- na.omit(temp_NO2) #126056

SRSsample <- SRS_NO2$NO2
B3Dsample <- B3D_NO2$NO2

n <- length(SRSsample)
N <- length(B3Dsample)

Xbar_NO2 <- mean(SRSsample)
Ybar_NO2 <- mean(B3Dsample)

plot(density(B3Dsample), type="l", lwd=2, lty=1, col="blue", main="Density ozono")
lines(density(SRSsample), col="red",  lwd=2, lty=1)
h_pil <- density(SRSsample)$bw
b_pil <- density(B3Dsample)$bw


p <- 100000
obtida <-0.05
num_vent<-101
vent_ini<-obtida/10
vent_fin<-obtida*10000
rho<-(vent_fin/vent_ini)^(1/(num_vent-1))
ventanas<-vent_ini*rho^(0:(num_vent-1))
ventanab <- ventanas
ventanah <- ventanas
v <- length(ventanas)

part_2<- matrix(0, v, p)
part<- matrix(0, v, p)
dens_x<- matrix(0, v, p)
dens_y<- matrix(0, v, p)
inv_wbh <- matrix(0, v, p)
mu_est_wbh_NO2_boots <- matrix(0, v, v)
ecmx_NO2_boots<-0
ecmy_NO2_boots<-0
ecmwbh_NO2_boots<-matrix(0, v, v)

B <- 100
dif_NO2_boots <- matrix(0, 10201, B)
set.seed(123456)
tiempo.ini<-proc.time()
for (j in 1:B){
  xboots <- sample(SRSsample, n, replace = TRUE) + h_pil*rnorm(n, 0, 1)
  yboots <- sample(B3Dsample, N, replace = TRUE) + b_pil*rnorm(N, 0, 1) 
  
  for (s in 1:v)
  {
    a <- min(xboots) - ventanah[s]*3
    c <- max(xboots) + ventanah[s]*3
    
    
    part_2<-density(xboots,ventanah[s],n=p,from=a,to=c)$x
    dens_x[s,]<-density(xboots,ventanah[s],n=p,from=a,to=c)$y
    dens_x_h <- approxfun(part_2,dens_x[s,],rule=2)
    
    for (i in 1:v)
    {
      a <- min(yboots)- ventanab[i]*3
      c <- max(yboots) + ventanab[i]*3
      
      
      part<-density(yboots,ventanab[i],n=p,from=a,to=c)$x
      dens_y[i,]<-density(yboots,ventanab[i],n=p,from=a,to=c)$y
      dens_y_b <- approxfun(part,dens_y[i,],rule=2)
      
      inv_weight_bh <-function(x)
      {
        result_4<-dens_x_h(x)/dens_y_b(x)
        return(result_4)
      }
      
      inv_w_y_bh<-inv_weight_bh(yboots)
      y_div_w_y_bh<-yboots*inv_w_y_bh
      
      mu_est_wbh_NO2_boots[s,i]<-mean(y_div_w_y_bh)/mean(inv_w_y_bh)
      ecmwbh_NO2_boots[s,i]<-ecmwbh_NO2_boots[s,i]+(mu_est_wbh_NO2_boots[s,i]-Xbar_NO2)^2
    }
  }
  dif_NO2_boots[,j] <- as.vector(t((mu_est_wbh_NO2_boots-Xbar_NO2)^2)) 
  #1:101 bwh1 101 bwb, 102:202 bwh2 101bwb...
}

tiempo.fin<-proc.time()
tiempo<-tiempo.fin-tiempo.ini;tiempo

ntrim <- 0.99*B
median_NO2_boots <- apply(dif_NO2_boots,1,median)
NO2_boots_ord <- t(apply(dif_NO2_boots,1,sort))
ecmwbh_trim_NO2_boots <- apply(NO2_boots_ord[,1:ntrim],1,mean)
ecmwbh_NO2_boots<-ecmwbh_NO2_boots/B;ecmwbh_NO2_boots

min(ecmwbh_NO2_boots);which.min(ecmwbh_NO2_boots)

indb_NO2_boots <- ceiling(which.min(ecmwbh_NO2_boots)/101)
indh_NO2_boots <- which.min(ecmwbh_NO2_boots)-101*floor(which.min(ecmwbh_NO2_boots)/101-0.01)

indh_NO2_boots;indb_NO2_boots
ventanah;ventanab


# MEAN ESTIMATION OPTIMAL BWS BOOTSTRAP: O3 -----


load("ozone.RData")
SRS_ozono <- na.omit(temp_ozono[temp_ozono$Temperatura>=30,]) #275
B3D_ozono <- na.omit(temp_ozono) #125949
SRSsample <- SRS_ozono$Ozono
B3Dsample <- B3D_ozono$Ozono

Xbar_O3 <- mean(SRSsample)
Ybar_O3 <- mean(B3Dsample)

p <- 100000
obtida <-0.05
num_vent<-101
vent_ini<-obtida/10
vent_fin<-obtida*10000
rho<-(vent_fin/vent_ini)^(1/(num_vent-1))
ventanas<-vent_ini*rho^(0:(num_vent-1))

ventanah <- ventanas[92]
ventanab <- ventanas[19]
v <- 1

part_2<- matrix(0, v, p)
part<- matrix(0, v, p)
dens_x<- matrix(0, v, p)
dens_y<- matrix(0, v, p)
inv_wbh <- matrix(0, v, p)
mu_est_wbh_O3 <- matrix(0, v, v)
for (s in 1:v)
{
  a <- min(SRSsample) - ventanah[s]*3
  c <- max(SRSsample) + ventanah[s]*3
  
  
  part_2<-density(SRSsample,ventanah[s],n=p,from=a,to=c)$x
  dens_x[s,]<-density(SRSsample,ventanah[s],n=p,from=a,to=c)$y
  dens_x_h <- approxfun(part_2,dens_x[s,],rule=2)
  
  for (i in 1:v)
  {
    a <- min(B3Dsample)- ventanab[i]*3
    c <- max(B3Dsample) + ventanab[i]*3
    
    
    part<-density(B3Dsample,ventanab[i],n=p,from=a,to=c)$x
    dens_y[i,]<-density(B3Dsample,ventanab[i],n=p,from=a,to=c)$y
    dens_y_b <- approxfun(part,dens_y[i,],rule=2)
    
    inv_weight_bh <-function(x)
    {
      result_4<-dens_x_h(x)/dens_y_b(x)
      return(result_4)
    }
    
    inv_w_y_bh<-inv_weight_bh(B3Dsample)
    y_div_w_y_bh<-B3Dsample*inv_w_y_bh
    
    mu_est_wbh_O3[s,i]<-mean(y_div_w_y_bh)/mean(inv_w_y_bh)
  }
}

Xbar_O3; Ybar_O3; mu_est_wbh_O3

# MEAN ESTIMATION OPTIMAL BWS BOOTSTRAP: NO2 -----

load("nitrogendioxide.RData")

SRS_NO2 <- na.omit(temp_NO2[temp_NO2$Temperatura>=30,]) #267 
B3D_NO2 <- na.omit(temp_NO2) #126056

SRSsample <- SRS_NO2$NO2
B3Dsample <- B3D_NO2$NO2

Xbar_NO2 <- mean(SRSsample)
Ybar_NO2 <- mean(B3Dsample)

p <- 100000
obtida <-0.05
num_vent<-101
vent_ini<-obtida/10
vent_fin<-obtida*10000
rho<-(vent_fin/vent_ini)^(1/(num_vent-1))
ventanas<-vent_ini*rho^(0:(num_vent-1))

ventanah <- ventanas[85]
ventanab <- ventanas[81]
v <- 1

part_2<- matrix(0, v, p)
part<- matrix(0, v, p)
dens_x<- matrix(0, v, p)
dens_y<- matrix(0, v, p)
inv_wbh <- matrix(0, v, p)
mu_est_wbh_NO2<- matrix(0, v, v)
for (s in 1:v)
{
  a <- min(SRSsample) - ventanah[s]*3
  c <- max(SRSsample) + ventanah[s]*3
  
  
  part_2<-density(SRSsample,ventanah[s],n=p,from=a,to=c)$x
  dens_x[s,]<-density(SRSsample,ventanah[s],n=p,from=a,to=c)$y
  dens_x_h <- approxfun(part_2,dens_x[s,],rule=2)
  
  for (i in 1:v)
  {
    a <- min(B3Dsample)- ventanab[i]*3
    c <- max(B3Dsample) + ventanab[i]*3
    
    
    part<-density(B3Dsample,ventanab[i],n=p,from=a,to=c)$x
    dens_y[i,]<-density(B3Dsample,ventanab[i],n=p,from=a,to=c)$y
    dens_y_b <- approxfun(part,dens_y[i,],rule=2)
    
    inv_weight_bh <-function(x)
    {
      result_4<-dens_x_h(x)/dens_y_b(x)
      return(result_4)
    }
    
    inv_w_y_bh<-inv_weight_bh(B3Dsample)
    y_div_w_y_bh<-B3Dsample*inv_w_y_bh
    
    mu_est_wbh_NO2[s,i]<-mean(y_div_w_y_bh)/mean(inv_w_y_bh)
  }
}

Xbar_NO2; Ybar_NO2; mu_est_wbh_NO2




# DISTRIBUTION FUNCTION ESTIMATION: O3 ----

load("ozone.RData")
SRS_ozono <- na.omit(temp_ozono[temp_ozono$Temperatura>=30,]) #275
B3D_ozono <- na.omit(temp_ozono) #125949
SRSsample <- SRS_ozono$Ozono
B3Dsample <- B3D_ozono$Ozono

Fn_O3 <- ecdf(SRSsample)
GN_O3 <- ecdf(B3Dsample)

ventanah<-199.05
ventanab<-0.0397

p <- 100000
v <- length(ventanah)

library(seewave)
library(spatstat)

a <- min(SRSsample) - ventanah*3
c <- max(SRSsample) + ventanah*3
part_2<-density(SRSsample,ventanah,n=p,from=a,to=c)$x
dens_x<-density(SRSsample,ventanah,n=p,from=a,to=c)$y
dens_x_h <- approxfun(part_2,dens_x,rule=2)
a <- min(B3Dsample)- ventanab*3
c <- max(B3Dsample) + ventanab*3
part<-density(B3Dsample,ventanab,n=p,from=a,to=c)$x
dens_y<-density(B3Dsample,ventanab,n=p,from=a,to=c)$y
dens_y_b <- approxfun(part,dens_y,rule=2)
inv_weight_bh <-function(x)
{
  result_4<-dens_x_h(x)/dens_y_b(x)
  return(result_4)
}
inv_w_y_bh<-inv_weight_bh(B3Dsample)
dist_est_wbh_O3<-ewcdf(B3Dsample, weights=inv_w_y_bh)


# DISTRIBUTION FUNCTION ESTIMATION: NO2 ----

load("nitrogendioxide.RData")

SRS_NO2 <- na.omit(temp_NO2[temp_NO2$Temperatura>=30,]) #267 
B3D_NO2 <- na.omit(temp_NO2) #126056

SRSsample <- SRS_NO2$NO2
B3Dsample <- B3D_NO2$NO2


Fn_NO2 <- ecdf(SRSsample)
GN_NO2 <- ecdf(B3Dsample)

ventanah<-79.24
ventanab<-50

p <- 100000
v <- length(ventanah)

library(seewave)
library(spatstat)

a <- min(SRSsample) - ventanah*3
c <- max(SRSsample) + ventanah*3
part_2<-density(SRSsample,ventanah,n=p,from=a,to=c)$x
dens_x<-density(SRSsample,ventanah,n=p,from=a,to=c)$y
dens_x_h <- approxfun(part_2,dens_x,rule=2)
a <- min(B3Dsample)- ventanab*3
c <- max(B3Dsample) + ventanab*3
part<-density(B3Dsample,ventanab,n=p,from=a,to=c)$x
dens_y<-density(B3Dsample,ventanab,n=p,from=a,to=c)$y
dens_y_b <- approxfun(part,dens_y,rule=2)
inv_weight_bh <-function(x)
{
  result_4<-dens_x_h(x)/dens_y_b(x)
  return(result_4)
}
inv_w_y_bh<-inv_weight_bh(B3Dsample)
dist_est_wbh_NO2<-ewcdf(B3Dsample, weights=inv_w_y_bh)

# REGRESSION MODEL ---- 

ksmooth(x, y, kernel = c("box", "normal"), bandwidth = 0.5,
        range.x = range(x),
        n.points = max(100L, length(x)), x.points)

model1 <- ksmooth(B3D_NO2$Temperatura, B3D_NO2$NO2, kernel = "normal", bandwidth = 0.5)
unique(model1$y)
model1
model1 <- ksmooth(B3D_NO2$Temperatura, B3D_NO2$NO2, kernel = "normal", bandwidth = 0.5, x.points = SRS_NO2$Temperatura)

plot(B3D_NO2$Temperatura, B3D_NO2$NO2)
lines(ksmooth(B3D_NO2$Temperatura, B3D_NO2$NO2, "normal", bandwidth = 2), col = 2)
lines(ksmooth(B3D_NO2$Temperatura, B3D_NO2$NO2, "normal", bandwidth = 5), col = 3)


NadarayaWatsonkernel(x, y, h, gridpoint)

# FIGURES ----

windows()
par(mfrow=c(1,2))
plot(density(B3D_ozono$Ozono), type="l", lwd=2, lty=1,bty="n", col="black", main="Ozone", ylab="", xlab="(a)")
lines(density(SRS_ozono$Ozono), col="gray45",  lwd=2, lty=2)
legend("topright", c("B3D", "SRS"), col=c("black", "gray45"), lwd=2, lty=c(1,2), bty="n", cex=1.5)

plot(density(B3D_NO2$NO2), type="l", lwd=2, lty=1,bty="n", col="black", main="Nitrogen dioxide", ylab="", xlab="(b)")
lines(density(SRS_NO2$NO2), col="gray45",  lwd=2, lty=2)
legend("topright", c("B3D", "SRS"), col=c("black", "gray45"), lwd=2, lty=c(1,2), bty="n", cex=1.5)

windows()
par(mfrow=c(2,2))
boxplot(B3D_ozono$Ozono, main="Ozone B3D", xlab="(a)")
boxplot(SRS_ozono$Ozono, main="Ozone SRS", xlab="(b)")

boxplot(B3D_NO2$NO2, main="Nitrogen Dioxide B3D", xlab="(c)")
boxplot(SRS_NO2$NO2, main="Nitrogen Dioxide SRS", xlab="(d)")


windows()
par(mfrow=c(1,2))
boxplot(B3D_ozono$Ozono, SRS_ozono$Ozono,main="Ozone", xlab="(a)",names = c("B3D", "SRS"),
        las = 1)
boxplot(B3D_NO2$NO2, SRS_NO2$NO2, main="Nitrogen Dioxide", xlab="(b)",names = c("B3D", "SRS"),
        las = 1)

library(viridis)
ventanah2 <- c(0.005,0.05,0.5,5,50,500)
ventanah22 <- round(ventanah2,3)
ventanab2 <- c(0.005,0.05,0.5,5,50,500)
ventanab22 <- round(ventanab2,3)
err <- c(0.01,0.1,1,10,100,1000)

filled.contour(log10(ventanah), log10(ventanab), log10(ecmwbh_O3_boots),
               plot.title = title(main = "", xlab = "h", ylab = "b"),              
               plot.axes = {contour(log10(ventanah), log10(ventanab), log10(ecmwbh_O3_boots), nlevels = 23, drawlabels = F,
                                    levels=c(4.951721,363.784),lwd=c(3,3), lty=c(1,2),col=c("gray","black"),add = TRUE);
                 axis(2, at=log10(ventanab2), label=ventanab22);
                 axis(1, at=log10(ventanah2), label=ventanah22)},
               key.axes = axis(4, at=log10(err), label=err),
               nlevels = 22,col = viridis(21))
filled.contour(log10(ventanah), log10(ventanab), log10(ecmwbh_NO2_boots),
               plot.title = title(main = "", xlab = "h", ylab = "b"),
               plot.axes = {contour(log10(ventanah), log10(ventanab), log10(ecmwbh_NO2_boots), nlevels = 23, drawlabels = F,
                                    levels=c(4.951721,363.784),lwd=c(3,3), lty=c(1,2),col=c("gray","black"),add = TRUE);
                 axis(2, at=log10(ventanab2), label=ventanab22);
                 axis(1, at=log10(ventanah2), label=ventanah22)},
               key.axes = axis(4, at=log10(err), label=err),
               nlevels = 20,col = viridis(28))



windows()
par(mfrow=c(1,2))
plot(GN_O3, lwd=3, lty=1, col="darkslateblue", main="Ozone", ylab="", xlab="(a)")
lines(Fn_O3, col="springgreen2",  lwd=2, lty=1)
lines(dist_est_wbh_O3, col="yellow1",  lwd=3, lty=1)
legend("bottomright", c("B3D", "SRS", "NEW"), col=c("darkslateblue", "springgreen2","yellow1"), lwd=3, lty=1, bty="n", cex=1.5)

plot(GN_NO2, lwd=3, lty=1, col="darkslateblue", main="Nitrogen dioxide", ylab="", xlab="(b)")
lines(Fn_NO2, col="springgreen2",  lwd=2, lty=1)
lines(dist_est_wbh_NO2, col="yellow1",  lwd=3, lty=1)
legend("bottomright", c("B3D", "SRS", "NEW"), col=c("darkslateblue", "springgreen2","yellow1"), lwd=3, lty=1, bty="n", cex=1.5)

